/* -*- MaTX -*-
 *
 * tmd00008.h: TMD No. tmd00008 ư֤Υɥž
 *
 *  Originally written by KIYOTA Hiromitsu <1999/06/03>
 *  Copyright (c) 1999 Hiromitsu Kiyota, kiyota@ds.mei.titech.ac.jp
 *
 * RCS: $Id: tmd00008.h,v 1.1 1999/06/03 11:49:13 kiyota Exp $
 */

#ifndef _TMD00008_H
#define _TMD00008_H

#ifdef TMD_USER_H
#include TMD_USER_H
#endif /* TMD_USER_H */

#ifdef TMD00008_USER_H
#include TMD00008_USER_H
#endif /* TMD00008_USER_H */

#ifndef TMD00008_MM
#define TMD00008_MM "tmd00008.mm"
#endif /* !TMD00008_MM */

#ifdef TMD_ENABLE_PACKAGE
#ifdef TMD_ANSI
#define tmd00008(var) _tmd00008_ ## var
#else /* ! TMD_ANSI */
#define tmd00008(var) _tmd00008_/**/var
#endif /* TMD_ANSI */
#else /* ! TMD_ENABLE_PACKAGE */
#define tmd00008(var) var
#endif /* TMD_ENABLE_PACKAGE */

#ifndef TMD_EXTERN
#define TMD_EXTERN
#endif /* ! TMD_EXTERN */

// ǥξ(x)(u)(y)μο
#define TMD00008_DIM_STATE 2
#define TMD00008_DIM_INPUT 2
#define TMD00008_DIM_OUTPUT 1
#define TMD00008_DIM_ALL_IOS (TMD00008_DIM_INPUT+TMD00008_DIM_OUTPUT)

// ǥξ֡ξ֡ϤڤФԤʤޥ(ؿ)
#define chop_state_tmd00008(xx) [xx(1:TMD00008_DIM_STATE)]
#define chop_other_state_tmd00008(xx) [xx(TMD00008_DIM_STATE+1:)]
#define chop_input_tmd00008(uu) [uu(1:TMD00008_DIM_INPUT)]

// ǥ(ʪ)ѥ᡼
TMD_EXTERN Real tmd00008(Vm), tmd00008(Vh), tmd00008(etav), tmd00008(J);
TMD_EXTERN Real tmd00008(c), tmd00008(etavo), tmd00008(Neo), tmd00008(Pbo);
TMD_EXTERN Real tmd00008(Gao), tmd00008(taua), tmd00008(Kp), tmd00008(Kd);
TMD_EXTERN Real tmd00008(taud), tmd00008(L);
TMD_EXTERN Matrix tmd00008(Aa), tmd00008(Ba), tmd00008(Ca), tmd00008(Da);
TMD_EXTERN Matrix tmd00008(Ad), tmd00008(Bd), tmd00008(Cd), tmd00008(Dd);

// ѥåե饰: 1 ǥ; 0 ǥȤ
#ifdef TMD_DISABLE_HALIST
#define TMD00008_DISABLE_HALIST
#endif /* TMD_DISABLE_HALIST */
#ifdef TMD00008_DISABLE_HALIST
TMD_EXTERN Integer tmd00008_flag;
#endif /* TMD00008_DISABLE_HALIST */

// ؿ
#if !defined(TMD_USER_MM) && !defined(TMD00008_USER_MM) || !defined(TMD_DIVIDED_COMPILE) && !defined(TMD00008_DIVIDED_COMPILE)
#include TMD00008_MM
#else /* !(!TMD_USER_MM && !TMD00008_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00008_DIVIDED_COMPILE) */
void init_tmd00008(/* linear_flag, params_flag, */ ...); // require TMD00008_MM;
Matrix diff_tmd00008(/* t, x, u */); // require TMD00008_MM;
Matrix output_tmd00008(/* t, x, u */); // require TMD00008_MM;
#endif /* !TMD_USER_MM && !TMD00008_USER_MM || !TMD_DIVIDED_COMPILE && !TMD00008_DIVIDED_COMPILE */

#undef TMD_EXTERN
#endif /* ! _TMD00008_H */
